#include<stdio.h>
#include<strings.h>
int main(void){
	int ga,ao,gb,gab;
	int pp;//potrebno pacijentu a i tao dalje...
	int n;
	int i;
	int ima,imb,imo,imab;
	int niz2[100];
    char grupa[]={'A','AB','B','O'};
    char niz[100];
	int bro[100],bra[100],brb[100],brab[100];
	scanf("%d\n",&n);
	scanf("%d %d %d %d",&imo,&ima,&imb,&imab);
	for(i=0;i<n;i++){
		scanf("%s %d",&niz[i],&niz2[i]);
	
	
		
	}
	int t=0;
	int t2=0,t3=0,t4=0;
	for(i=0;i<n;i++){
		if(niz[i]== grupa[0] &&(niz2[i]==ima||niz2[i]<ima)){
			t=1;
			ima=ima-niz2[i];
			bro[i]=0;
			bra[i]+=niz2[i];
			brb[i]=0;
			brab[i]=0;
			
			continue;
			
		}
		else if(niz[i]==grupa[0] &&(niz2[i]==imo||niz2[i]<imo)){
			t=1;
			
			bro[i]=niz2[i];
			bra[i]=0;
			brb[i]=0;
			brab[i]=0;
			
			continue;
		}
	};
	
	for(i=0;i<n;i++){
		
		if(niz[i]== grupa[2] &&(niz2[i]==imb||niz2[i]<imb)){
		
		t3=1;
		imb=imb-niz2[i];
		bro[i]=0;
		bra[i]=0;
		brb[i]=niz2[i];
		brab[i]=0;
	
			
		
		continue;
		
	}
	else if(niz[i]==grupa[2]  &&(niz2[i]==imo||niz2[i]<imo)){
		t3=1;
		imo=imo-niz2[i];
		bro[i]+=niz[i];
		bra[i]=0;
	    brb[i]=0;
		brab[i]=0;
			
	
		continue;
	}
		
	};
	for(i=0;i<n;i++){
		if(niz[i]==grupa[3] &&(niz2[i]==imo||niz2[i]<imo)){
		t2=1;
		imo=imo-niz2[i];
		bro[i]+=niz2[i];
		bra[i]=0;
		brb[i]=0;
		brab[i]=0;
			
	
		continue;
	}
	else if(niz[i]!=grupa[3] )t2=1;
		
	};

	
	
	for(i=0;i<n;i++){
		if(niz[i]==grupa[1]&&(niz2[i]==imab||niz2[i]<imab||niz2[i]>imab)){
			t4=1;
		
			if(imo<niz2[i]){
				bro[i]=imo;
				bra[i]=0;
				brb[i]=0;
				brab[i]=imab;
	  }
			
		
			
		}
		else if(niz[i]==grupa[1]&&(niz2[i]==imo||niz2[i]<imo)){
		t4=1;
		imo=imo-niz2[i];
	
		continue;
	}
	    else if(niz[i]==grupa[1]&&(niz2[i]==ima||niz2[i]<ima)){
		t4=1;
		ima=ima-niz2[i];
		
		
	}
	    else if(niz[i]==grupa[1] &&(niz2[i]==ima||niz2[i]<ima)){
		t4=1;
		imb=imb-niz2[i];
		
		continue;
	}
	
	
	    
	};
	
	if(t==1&&t2==1&&t3==1&&t4==1){
	printf("moguce\n");
	for(i=0;i<n;i++){
		
		printf("%d %d %d %d\n",bro[i],bra[i],brb[i],brab[i]);
	}
	
	
}
	else printf("nemoguce");
	return 0;
}